#Extract file(s) and send via SFTP
#Automatically use the most recent db given the suffix

Clear-Host

$SQLuser =   "username"
$SQLPass =   "password"
$SQLServer = "servername(FQDN)"
$OutPath =   "C:\Scripts\DISTRICT\EXTRACTNAME\Output\"
$FileName =  "students.csv" #Define for one file or individually for multiple files below
$DBSuffix = "AeriesDemo"

$currentYearDB = 
    Invoke-Sqlcmd -serverinstance $SQLServer -database master -username $SQLUser -password $SQLPass -TrustServerCertificate -query "
        DECLARE @SUFFIX VARCHAR(60) = '$DBSuffix';
        SELECT top(1) [NAME] FROM SYS.DATABASES WHERE [NAME] LIKE '%' + @SUFFIX AND [NAME] NOT LIKE '%[_]%'
        ORDER BY [NAME] DESC
    "
$SQLDB = $currentYearDB.NAME


#SFTP server info
$doSFTP = 0							 #Enable/Disable SFTP 0=no, 1=yes
$strSN  = "SFTPserver"               #SFTP Server Name or Static IP 
$strUN  = "SFTPusername"             #SFTP UserName
$strPW  = "SFTPpassword"             #SFTP Password
$strRD  = "RemoteDirectory"			 #SFTP Remove Directory
$sshKey = "ssh-rsa 1024 ..."		 #SSH Key

# Load WinSCP .NET assembly
Add-Type -Path "C:\WinSCP\WinSCPnet.dll"
$MyDir = [System.IO.Path]::GetDirectoryName($myInvocation.MyCommand.Definition)
Set-Location $mydir


if ($null -ne $SQLDB) {

    Invoke-Sqlcmd -serverinstance $SQLServer -database $SQLDB -username $SQLUser -password $SQLPass -TrustServerCertificate -query "

    --insert SQL statement here


    " | Export-Csv -NoTypeInformation -Path $OutPath\$filename

    #" | ConvertTo-Csv -NoTypeInformation | % {$_.Replace('"','')} | out-file $Outpath\EmailList.csv

} else {Write-Output "No database found with the provided suffix"}


if ($doSFTP -eq 1){

	$sessionOptions = New-Object WinSCP.SessionOptions -Property @{
		Protocol = [WinSCP.Protocol]::Sftp
		HostName = $strSN
		UserName = $strUN
		Password = $strPW
		#GiveUpSecurityAndAcceptAnySshHostKey = "True"
		SshHostKeyFingerprint = $sshKey   	
	}

	$session = New-Object WinSCP.Session

	try
	{
		# Connect
		$session.Open($sessionOptions)
		$transferOptions = New-Object winscp.TransferOptions
		$transferOptions.TransferMode = [WinSCP.TransferMode]::Ascii
		#$transferOptions.PreserveTimestamp = $false	
		
		# Upload
		# $session.PutFiles($Outfile, $strRD, $false, $transferOptions)

		# PutFilesToDirectory(localDirectory, remoteDirectory, filemask, remove, options)
		$session.PutFilesToDirectory($OutPath, $strRD, "*.csv", $false, $transferOptions).Check()
	}
	finally
	{
		# Disconnect, clean up
		$session.Dispose()
	}
}